=== tests/external/CMakeLists.txt ===
#
# Copyright 2018-2019, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

include(../ctest_helpers.cmake)

function(add_test_expect_failure name)
	set(srcs ${ARGN})
	prepend(srcs ${CMAKE_CURRENT_SOURCE_DIR} ${srcs})

	add_cppstyle(tests-external-${name} ${srcs})
	add_check_whitespace(tests-external-${name} ${srcs})

	add_executable(${name}_fail_expected ${srcs})
	set_target_properties(${name}_fail_expected PROPERTIES
				EXCLUDE_FROM_ALL TRUE
				EXCLUDE_FROM_DEFAULT_BUILD TRUE)

	add_test(NAME ${name}_fail_expected
		COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target ${name}_fail_expected
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

	set_tests_properties(${name}_fail_expected PROPERTIES WILL_FAIL TRUE)
endfunction()

if (ENABLE_ARRAY)
	build_test(array_at libcxx/array/at.pass.cpp)
	add_test_generic(NAME array_at TRACERS none)

	build_test(array_begin libcxx/array/begin.pass.cpp)
	add_test_generic(NAME array_begin TRACERS none)

	build_test(array_compare libcxx/array/compare.pass.cpp)
	add_test_generic(NAME array_compare TRACERS none)

	build_test(array_contiguous libcxx/array/contiguous.pass.cpp)
	add_test_generic(NAME array_contiguous TRACERS none)

	build_test(array_empty libcxx/array/empty.pass.cpp)
	add_test_generic(NAME array_empty TRACERS none)

	build_test(array_front_back libcxx/array/front_back.pass.cpp)
	add_test_generic(NAME array_front_back TRACERS none)

	build_test(array_indexing libcxx/array/indexing.pass.cpp)
	add_test_generic(NAME array_indexing TRACERS none)

	build_test(array_max_size libcxx/array/max_size.pass.cpp)
	add_test_generic(NAME array_max_size TRACERS none)

	if (MAX_ALIGN_TYPE_EXISTS)
		build_test(array_size_and_alignment libcxx/array/size_and_alignment.pass.cpp)
		add_test_generic(NAME array_size_and_alignment TRACERS none)
	endif()

	build_test(array_types libcxx/array/types.pass.cpp)
	add_test_generic(NAME array_types TRACERS none)

	add_test_expect_failure(array_compare_0 libcxx/array/compare.fail_0.cpp)
	add_test_expect_failure(array_compare_1 libcxx/array/compare.fail_1.cpp)
	add_test_expect_failure(array_compare_2 libcxx/array/compare.fail_2.cpp)

	build_test(array_cons_default libcxx/array/array.cons/default.pass.cpp)
	add_test_generic(NAME array_cons_default TRACERS none)

	add_test_expect_failure(array_copy_assignment libcxx/array/array.cons/copy_assignment.fail.cpp)

	build_test(array_cons_implicit_copy libcxx/array/array.cons/implicit_copy.pass.cpp)
	add_test_generic(NAME array_cons_implicit_copy TRACERS none)

	build_test(array_initializer_list libcxx/array/array.cons/initializer_list.pass.cpp)
	add_test_generic(NAME array_initializer_list TRACERS none)

	if (MAX_ALIGN_TYPE_EXISTS)
		build_test(array_data_const libcxx/array/array.data/data_const.pass.cpp)
		add_test_generic(NAME array_data_const TRACERS none)
	endif()

	if (MAX_ALIGN_TYPE_EXISTS)
		build_test(array_data libcxx/array/array.data/data.pass.cpp)
		add_test_generic(NAME array_data TRACERS none)
	endif()

	add_test_expect_failure(array_fill libcxx/array/array.fill/fill.fail.cpp)

	build_test(array_fill libcxx/array/array.fill/fill.pass.cpp)
	add_test_generic(NAME array_fill TRACERS none)

	build_test(array_size libcxx/array/array.size/size.pass.cpp)
	add_test_generic(NAME array_size TRACERS none)

	build_test(array_swap libcxx/array/array.special/swap.pass.cpp)
	add_test_generic(NAME array_swap TRACERS none)

	add_test_expect_failure(array_swap libcxx/array/array.swap/swap.fail.cpp)

	build_test(array_swap_2 libcxx/array/array.swap/swap.pass.cpp)
	add_test_generic(NAME array_swap_2 TRACERS none)

	build_test(array_get_const_rv libcxx/array/array.tuple/get_const_rv.pass.cpp)
	add_test_generic(NAME array_get_const_rv TRACERS none)

	build_test(array_get_const libcxx/array/array.tuple/get_const.pass.cpp)
	add_test_generic(NAME array_get_const TRACERS none)

	build_test(array_get_rv libcxx/array/array.tuple/get_rv.pass.cpp)
	add_test_generic(NAME array_get_rv TRACERS none)

	build_test(array_get libcxx/array/array.tuple/get.pass.cpp)
	add_test_generic(NAME array_get TRACERS none)

	add_test_expect_failure(array_get libcxx/array/array.tuple/get.fail.cpp)

	build_test(array_iterators libcxx/array/iterators.pass.cpp)
	add_test_generic(NAME array_iterators TRACERS none)
endif()

if (ENABLE_VECTOR)
	build_test(vector_libcxx_assign_copy libcxx/vector/vector.cons/assign_copy.pass.cpp)
	add_test_generic(NAME vector_libcxx_assign_copy TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_assign_initializer_list libcxx/vector/vector.cons/assign_initializer_list.pass.cpp)
	add_test_generic(NAME vector_libcxx_assign_initializer_list TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_assign_iter_iter libcxx/vector/vector.cons/assign_iter_iter.pass.cpp)
	add_test_generic(NAME vector_libcxx_assign_iter_iter TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_assign_move_pass libcxx/vector/vector.cons/assign_move.pass.cpp)
	add_test_generic(NAME vector_libcxx_assign_move_pass TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_assign_size_value libcxx/vector/vector.cons/assign_size_value.pass.cpp)
	add_test_generic(NAME vector_libcxx_assign_size_value TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_ctor_default libcxx/vector/vector.cons/construct_default.pass.cpp)
	add_test_generic(NAME vector_libcxx_ctor_default TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_ctor_iter_iter libcxx/vector/vector.cons/construct_iter_iter.pass.cpp)
	add_test_generic(NAME vector_libcxx_ctor_iter_iter TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_ctor_move libcxx/vector/vector.cons/move.pass.cpp)
	add_test_generic(NAME vector_libcxx_ctor_move TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_ctor_size libcxx/vector/vector.cons/construct_size.pass.cpp)
	add_test_generic(NAME vector_libcxx_ctor_size TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_ctor_size_value libcxx/vector/vector.cons/construct_size_value.pass.cpp)
	add_test_generic(NAME vector_libcxx_ctor_size_value TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_copy libcxx/vector/vector.cons/copy.pass.cpp)
	add_test_generic(NAME vector_libcxx_copy TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_dtor_noexcept libcxx/vector/vector.cons/dtor_noexcept.pass.cpp)
	add_test_generic(NAME vector_libcxx_dtor_noexcept TRACERS none)

	build_test(vector_libcxx_contiguous libcxx/vector/contiguous.pass.cpp)
	add_test_generic(NAME vector_libcxx_contiguous TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_types libcxx/vector/types.pass.cpp)
	add_test_generic(NAME vector_libcxx_types TRACERS none)

	build_test(vector_libcxx_iterators libcxx/vector/iterators.pass.cpp)
	add_test_generic(NAME vector_libcxx_iterators TRACERS TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_data_const libcxx/vector/vector.data/data_const.pass.cpp)
	add_test_generic(NAME vector_libcxx_data_const TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_data libcxx/vector/vector.data/data.pass.cpp)
	add_test_generic(NAME vector_libcxx_data TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_initializer_list libcxx/vector/vector.cons/initializer_list.pass.cpp)
	add_test_generic(NAME vector_libcxx_initializer_list TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_op_equal_initializer_list libcxx/vector/vector.cons/op_equal_initializer_list.pass.cpp)
	add_test_generic(NAME vector_libcxx_op_equal_initializer_list TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_capacity libcxx/vector/vector.capacity/capacity.pass.cpp)
	add_test_generic(NAME vector_libcxx_capacity TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_empty libcxx/vector/vector.capacity/empty.pass.cpp)
	add_test_generic(NAME vector_libcxx_empty TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_max_size libcxx/vector/vector.capacity/max_size.pass.cpp)
	add_test_generic(NAME vector_libcxx_max_size TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_reserve libcxx/vector/vector.capacity/reserve.pass.cpp)
	add_test_generic(NAME vector_libcxx_reserve TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_resize_size libcxx/vector/vector.capacity/resize_size.pass.cpp)
	add_test_generic(NAME vector_libcxx_resize_size TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_resize_size_value libcxx/vector/vector.capacity/resize_size_value.pass.cpp)
	add_test_generic(NAME vector_libcxx_resize_size_value TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_shrink_to_fit libcxx/vector/vector.capacity/shrink_to_fit.pass.cpp)
	add_test_generic(NAME vector_libcxx_shrink_to_fit TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_size libcxx/vector/vector.capacity/size.pass.cpp)
	add_test_generic(NAME vector_libcxx_size TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_swap libcxx/vector/vector.capacity/swap.pass.cpp)
	add_test_generic(NAME vector_libcxx_swap TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_clear libcxx/vector/vector.modifiers/clear.pass.cpp)
	add_test_generic(NAME vector_libcxx_clear TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_emplace libcxx/vector/vector.modifiers/emplace.pass.cpp)
	add_test_generic(NAME vector_libcxx_emplace TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_emplace_back libcxx/vector/vector.modifiers/emplace_back.pass.cpp)
	add_test_generic(NAME vector_libcxx_emplace_back TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_emplace_extra libcxx/vector/vector.modifiers/emplace_extra.pass.cpp)
	add_test_generic(NAME vector_libcxx_emplace_extra TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_erase_iter libcxx/vector/vector.modifiers/erase_iter.pass.cpp)
	add_test_generic(NAME vector_libcxx_erase_iter TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_erase_iter_iter libcxx/vector/vector.modifiers/erase_iter_iter.pass.cpp)
	add_test_generic(NAME vector_libcxx_erase_iter_iter TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_insert_iter_initializer_list libcxx/vector/vector.modifiers/insert_iter_initializer_list.pass.cpp)
	add_test_generic(NAME vector_libcxx_insert_iter_initializer_list TRACERS none pmemcheck memcheck)

	build_test(vector_libcxx_insert_iter_iter_iter libcxx/vector/vector.modifiers/insert_iter_iter_iter.pass.cpp)
	add_test_generic(NAME vector_libcxx_insert_iter_iter_iter TRACERS none pmemcheck memcheck)
