=== debian/changelog ===
libpmemobj-cpp (1.7-2ubuntu4) eoan; urgency=medium

  * d/control, d/t/control: Drop extra deps added in 2ubuntu3 and 2ubuntu2, no
    longer needed with pmdk 1.6.1-1ubuntu1 which adds them to each *-dev package
    where needed.

 -- Andreas Hasenack <andreas@canonical.com>  Mon, 02 Sep 2019 11:06:55 -0300

libpmemobj-cpp (1.7-2ubuntu3) eoan; urgency=medium

  * d/control: add libndctl-dev and libdaxctl-dev to build-deps
    (LP: #1841463)

 -- Andreas Hasenack <andreas@canonical.com>  Mon, 26 Aug 2019 15:51:25 -0300

libpmemobj-cpp (1.7-2ubuntu2) eoan; urgency=medium

  * d/t/control: add missing libdaxctl-dev and libndctl-dev dep8 dependencies

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 22 Aug 2019 22:59:28 -0300

libpmemobj-cpp (1.7-2ubuntu1) eoan; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: add an explicit versioned dependency on libpmemobj-dev to
      match the build-depends version
  * Dropped:
    - d/control: setup transition from libpmemobj-doc to
      libpmemobj-cpp-doc, case #5 from https://wiki.debian.org/PackageTransition
      [Can be dropped after 20.04]
      [Included in 1.6-2]
    - d/control: setup split transition from libpmemobj-dev, case #7 from
      https://wiki.debian.org/PackageTransition
      [Can be dropped after 20.04]
      [Included in 1.6-2]
    - d/control: libpmemobj-cpp-dev is arch amd64 only
      [Included in 1.6-2]
    - d/control lintian fixes:
      + doc package belongs in the doc section
        [Included in 1.6-2]
      + update doc package's short description
        [Included in 1.6-2]

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 16 Aug 2019 14:43:32 -0300

libpmemobj-cpp (1.7-2) unstable; urgency=medium

  * Upload to unstable.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 08 Jul 2019 12:51:42 +0200

libpmemobj-cpp (1.7-1) experimental; urgency=medium

  * New upstream release.
  * Merge in Ubuntu changes:
    + Add Breaks/Replaces for ≤ Disco.
    + Set Architecture to amd64 only (Ubuntu can't cope with
      BD-Uninstallable).
    + Register with doc-base.
    + Set Section of the -doc package.
  * B-Dep on pmemobj 1.6 (runtime still works with 1.5).
  * During tests, pretend we're running on pmem, to avoid msync.
  * Cherry-pick an upstream fix for basic_string.
  * Give pmpong autopkgtest Dep: on fontconfig.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 28 Jun 2019 14:03:34 +0200

libpmemobj-cpp (1.6-2) experimental; urgency=medium

  * Sync Ubuntu changes:
    • -doc: Section: doc
    • -doc: better short desc
    • -doc: doc-base registration
    • -dev: mark as amd64 only (Ubuntu buildds can't handle B-Deps being
            unavailable on some archs)
    • Breaks/Replaces libpmemobj-* << 1.5 (Disco and lower)

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 24 May 2019 15:34:31 +0200

libpmemobj-cpp (1.6-1ubuntu1) eoan; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: setup transition from libpmemobj-doc to
      libpmemobj-cpp-doc, case #5 from https://wiki.debian.org/PackageTransition
      [Can be dropped after 20.04]
    - d/control: setup split transition from libpmemobj-dev, case #7 from
      https://wiki.debian.org/PackageTransition
      [Can be dropped after 20.04]
    - d/control: libpmemobj-cpp-dev is arch amd64 only
    - d/control: add an explicit versioned dependency on libpmemobj-dev to
      match the build-depends version
  * Added:
    - d/libpmemobj-cpp-doc.doc-base: register doc package with doc-base
    - d/control lintian fixes:
      + doc package belongs in the doc section
      + update doc package's short description

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 22 May 2019 18:11:47 +0000

libpmemobj-cpp (1.5.1-1ubuntu1) eoan; urgency=medium

  * d/control: setup transition from libpmemobj-doc to
    libpmemobj-cpp-doc, case #5 from https://wiki.debian.org/PackageTransition
    [Can be dropped after 20.04]
  * d/control: setup split transition from libpmemobj-dev, case #7 from
    https://wiki.debian.org/PackageTransition
    [Can be dropped after 20.04]
  * d/control: libpmemobj-cpp-dev is arch amd64 only
  * d/control: add an explicit versioned dependency on libpmemobj-dev to
    match the build-depends version

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 15 May 2019 13:58:45 +0000
