=== debian/control ===
Source: libpmemobj-cpp
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: cmake,
               debhelper (>= 11~),
               doxygen,
               graphviz,
               libncurses5-dev,
               libpmemobj-dev (>= 1.6~),
               libsfml-dev,
               libunwind-dev,
               pkg-config,
               valgrind
Standards-Version: 4.4.0
Section: libs
Homepage: https://pmem.io/pmdk/cpp_obj/
Vcs-Browser: https://github.com/kilobyte/libpmemobj-cpp
Vcs-Git: https://github.com/kilobyte/libpmemobj-cpp.git -b debian

Package: libpmemobj-cpp-dev
Section: libdevel
Architecture: amd64
Multi-Arch: same
Depends: libpmemobj-dev (>= 1.6~), ${misc:Depends}, ${shlibs:Depends}
# These versions were found in Ubuntu ≤ Disco; can be removed after 20.04.
Breaks: libpmemobj-dev (<< 1.5)
Replaces: libpmemobj-dev (<< 1.5)
Description: C++ bindings to libpmemobj
 The C++ bindings provide an easier to use (and thus less error prone
 version) of libpmemobj -- the persistent memory object store -- through
 the implementation of a pmem-resident property, persistent pointers,
 scoped and closure transactions, locking primitives and many others.
 .
 This package contains the development headers.

Package: libpmemobj-cpp-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
# These versions were found in Ubuntu ≤ Disco; can be removed after 20.04.
Breaks: libpmemobj-doc (<< 1.5)
Replaces: libpmemobj-doc (<< 1.5)
Description: C++ bindings to libpmemobj - documentation
 The C++ bindings provide an easier to use (and thus less error prone
 version) of libpmemobj -- the persistent memory object store -- through
 the implementation of a pmem-resident property, persistent pointers,
 scoped and closure transactions, locking primitives and many others.
 .
 This package contains the documentation.
